c  aicmdl.for  -  AIC and MDL criteria
c  their minimum values determine the dimension K of the noise subspace
c
c  lambda = empirical eigenvalues
c       N = number of snapshots
c
c  arithmetic and harmonic averages are computed recursively


       subroutine aicmdl(M, lambda, N, AIC, MDL)
       real lambda(0:M), AIC(M+1), MDL(M+1)

       real L

       avlog = 0
       av = 0

       do 1  k = 1, M+1
             av = av + (lambda(k-1) - av) / k
             avlog = avlog + (alog(lambda(k-1)) - avlog) / k
             L = (avlog - alog(av))
             AIC(k) = - 2 * N * k * L + 2 * (M + 1 - k) * (M + 1 + k)
             MDL(k) = - N*k*L + 0.5*(M+1-k)*(M+1+k)*alog(float(N))
1      continue

       return
       end
