       subroutine rls(M, h, x, y, xhat, e, lambda, init)
       real h(0:M), y(0:M), lambda

       parameter(MAX = 50, delta = 0.01)
       real k0(0:MAX), k1(0:MAX), P(0:MAX, 0:MAX)
       real mu, nu
       save P

       if (init .eq. 0) then
            do 1  i = 0, M
                  h(i) = 0
                  do 1  j = 0, M
                        if (j .eq. i) then
                             P(i, j) = 1 / delta
                        else
                             P(i, j) = 0
                        endif
1          continue
            init = 1
        endif

       do 2  i = 0, M
             k0(i) = 0
             do 2  j = 0, M
                   k0(i) = k0(i) + P(i, j) * y(j) / lambda
2     continue

       nu = 0
       do 3  i = 0, M
3            nu = nu + k0(i) * y(i)              

       mu = 1 / (1 + nu)

       do 4  i = 0, M
4            k1(i) = mu * k0(i)

       do 5  i = 0, M
             do 5  j = 0, i
                   P(i, j) = P(i, j) / lambda - k1(i) * k0(j)
                   P(j, i) = P(i, j)
5     continue

       xhat0 = 0
       do 6  i = 0, M
6            xhat0 = xhat0 + h(i) * y(i)

       e0 = x - xhat0

       e = mu * e0          

       xhat = x - e

       do 7  i = 0, M
7            h(i) = h(i) + e0 * k1(i)

       return
       end
